package com.rjconsultores.ventaboletos.service.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PricingCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.PricingCtrl;
import com.rjconsultores.ventaboletos.service.PricingCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("pricingCtrlService")
public class PricingCtrlServiceImpl implements PricingCtrlService {
	
	@Autowired
	private PricingCtrlDAO pricingCtrlDAO;

	@Override
	public List<PricingCtrl> obtenerTodos() {
		return pricingCtrlDAO.obtenerTodos();
	}

	@Override
	public PricingCtrl obtenerID(Integer id) {
		return pricingCtrlDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public PricingCtrl suscribir(PricingCtrl entidad) {
		entidad.setActivo(true);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(new Date());
		return pricingCtrlDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public PricingCtrl actualizacion(PricingCtrl entidad) {
		entidad.setActivo(true);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(new Date());
		return pricingCtrlDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(PricingCtrl entidad) {
		entidad.setActivo(false);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(new Date());
		pricingCtrlDAO.actualizacion(entidad);
	}

	@Override
	public PricingCtrl obtenerPricingCtrl() {
		return pricingCtrlDAO.obtenerPricingCtrl();
	}

	@Override
	@Transactional
	public PricingCtrl suscribirOrActualizacion(PricingCtrl entidad) {
		if(entidad.getPricingctrlId() == null) {
			return suscribir(entidad);
		} else {
			return actualizacion(entidad);
		}
	}

}
